1 'MENU59D.BAS
9 '------------
10 'A  = selected option
11 'CU = custom fonts flag
12 'CT = counter for color changes
13 'DE = destination in RAM for palette
14 'EX = address of printing routine
15 'GP = games in a screen page
16 'FE = first element on screen
17 'FR = first row filled with a game name
18 'FC = first column for options
19 'I,J= loop variables
20 'L  = charset name length
21 'MS = maxim speed allowed
22 'NG = number of games in pack
22 'OD = origin of data
24 'OG = beginning of pack data to copy
25 'PM = page marker for next - previous
26 'PN = page number
27 'PR = param to tell ml routine the page to be printed - line to be inverted
28 'SP = speed (0-1)
29 'WN = working number of games to print
30 'X  = selected color mode
40 'A$ = packed filename,working
41 'E$ = possible error source
42 'F$ = filename to be loaded (binary game)
43 'I$ = command sequence
99 '-------------
100 'MENU59D.BAS
110 '------------
120 CLEAR80:PCLEAR4:CLS:GP=12:FE=0:FR=2:FC=1:DE=&H1300:OD=&H6000:NG=0:CT=0:SP=0:MS=0:CU=0:PN=1:X=1:EX=&H4A09:PR=&H4A15:E$="UNKNOWN"
130 LOAD"TOOLS59D.BIN":EXEC&H4A12:'enable error trap
140 POKE&H19A,&H39:POKE&H19B,&H4C:POKE&H19C,&HAD:POKE&H19A,&H7E:FORI=1TO800:NEXT:'disable Break key
150 PRINT@128,"DOES YOUR COMPUTER SUPPORT ":PRINT"THE DOUBLE SPEED POKE?";
160 A$=INKEY$:IFA$="N"THEN170ELSEIFA$="Y"THENMS=1:GOTO170ELSE160 
170 GOSUB1000:READ A$:LOAD A$+".MUL":CLOSE ALL:'load needed binaries
180 IF PEEK(OD+58*NG)<>&HAA AND PEEK(OD+58*NG+1)<>&HBB THEN NG=NG+1:GOTO180
190 LOAD"LAUNCHED.BIN"
200 E$="UNKNOWN":IF NG<GP*PN THEN WN=NG-GP*(PN-1) ELSE WN=GP
210 '--- FILL A SCREEN WITH WN GAMES ---
220 POKEPR,PN:EXEC EX
230 PM=0:POKE&H400+446,48+VAL(RIGHT$(STR$(PN),1))
240 IF NG>FE+WN THEN PRINT@476,"DwN";:PM=PM+1ELSE PRINT@476,"   ";
250 IF FE>=GP THEN PRINT@473,"uP";:PM=PM+2ELSE PRINT@473,"  ";
260 IFX=0THENPRINT@90,"STD";ELSEPRINT@90,"NEW";
270 IFCU=0THENPRINT@346,"STD";ELSEPRINT@346,"NEW";
280 IFSP=0THENPRINT@218,"STD";
290 IFSP=1THENPRINT@218," 2X";
300 CT=CT+1:IFCT=64THENCT=0:EXEC&H4A0F
310 A$=INKEY$:IFA$=""THEN300
320 IFA$="X"THENCLS:POKE&HFFD6,0:POKE410,57:END
330 IFA$="O"THENX=1-X:GOTO260
340 IFA$="R"THENCU=1-CU:GOTO270
350 IFA$="S"THENSP=SP+1:IFSP>MS THENSP=0:GOTO280ELSE280:'control max speed allowed
360 IF(A$="W" AND ((PM AND1)=1))THEN PN=PN+1:FE=FE+GP:GOTO200 ELSE IF(A$="U" AND ((PM AND2)=2))THEN PN=PN-1:FE=FE-GP:GOTO200
370 A=ASC(A$)-64:IFA<1 OR A>WN THENSOUND100,1:GOTO230
380 OG=OD+58*(FE+A-1):'palette beginning for chosen game
390 POKE PR,A:EXEC&H4A0C
400 '--- GET THE BINARY FILENAME TO BE EXECUTED ---
410 F$="":FORI=1TO8:IFPEEK(OG+30+I-1)=0THENI=8:NEXT ELSE F$=F$+CHR$(PEEK(OG+30+I-1)):NEXT
420 IFCU=0THEN440
430 GOSUB1020:'load it. File should be .chr and load address $0e00
440 I$=CHR$(128):PRINT@481,"loading"+I$+I$+"starting"+I$+"game";
450 '--- ASK FOR COLORS TO BE USED ---
460 IF X=0 THEN EXEC&H4A00:GOTO 530:'reset to ensure default colors
470 '--- COPY THE PALETTE REGISTER TO BE USED ---
480 FORI=0TO29:POKE DE+I,PEEK(OG+I):NEXT
490 POKE(DE+3),PEEK(DE+3)AND&HFE:POKE(DE+8),PEEK(DE+8)AND&HFE:'reset charset bits to preserve the ones we have already loaded (menu or custom)
500 IF CU=1 THEN 520:'if custom fonts, don't set fonts bits
510 POKE(DE+0),PEEK(DE+0)OR1:'set param to reset fonts to default
520 EXEC&H4A03:'apply colors change
530 '--- SET A COMMAND SEQUENCE TO START THE GAME ---
540 IF(ASC(LEFT$(F$,1))AND128)=0 THEN570 ELSE MID$(F$,1,1)=CHR$(ASC(LEFT$(F$,1))AND127):'not a basic program
550 I$=CHR$(&H3A)+CHR$(&H8F)+CHR$(34)+F$+".BAS"+CHR$(34):GOTO590
560 ':run"F$.BAS" --> lowercase commands are tokenized
570 I$=CHR$(&H3A)+CHR$(&HDC)+CHR$(34)+F$+".BIN"+CHR$(34)+":"+CHR$(&H9C)+":"+CHR$(&H93)+"&HFF48,0:"+CHR$(&HA4)
580 ':load"F$.BIN":close:poke&HFF48,0:exec --> lowercase commands are tokenized
590 X=&H01F8:FORI=1TOLEN(I$):POKEX+I-1,ASC(MID$(I$,I,1)):NEXT:POKEX+I-1,0
600 FORI=0TO7:READA$:POKE&H01F0+I,VAL("&H"+A$):NEXT:IFSP=1THENPOKE&HFFD7,0
610 '----------------
620 'CLS:PRINTI$:PRINT:FORI=&H01F0 TO &H01F8+LEN(I$):PRINTHEX$(PEEK(I))" ";:NEXT:PRINT:STOP
630 '----------------
640 POKE&H19A,&H39:POKE&H18E,&H39:EXEC&H01F0:'exec/run enabling Break key and disabling error trap
650 '----------------
660 DATA PACKG02
670 DATA 8E,01,F8,9F,A6,7E,84,9F
680 'ldx  #$01f8
690 'stx  <$a6
700 'jmp  $849f
710 '----------------
720 END
1000 REM LOAD CHARACTER SET
1010 F$="MENUCHRD"
1020 E$="CHARSET":G$=F$:MID$(G$,1,1)=CHR$(ASC(LEFT$(G$,1))AND127)
1030 LOAD G$+".CHR":CLOSE:E$="UNKNOWN"
1040 EXEC&H4A06:'send new charset
1050 EXEC&H4A03:'apply changes"
1060 RETURN
2000 POKE&HFFD6,0:PRINT@480,E$+" ERROR - PRESS C ";
2010 IFINKEY$<>"C"THEN2010ELSEPRINT@480,STRING$(22,128);:PRINT@484,"choose"+STRING$(2,128)+"game";:PRINT@499,"ExIT"+CHR$(128);
2020 POKE&H19A,&H7E:POKE&H18E,&H7E:GOTO200:'disable break and enable error trap
63999 GOTO2000:'do not renum nor delete this line
